<?php

/** @var rex_addon $this */

// Diese Datei ist keine Pflichtdatei mehr.

// SQL-Anweisungen können auch weiterhin über die install.sql ausgeführt werden.

// Abhängigkeiten (PHP-Version, PHP-Extensions, Redaxo-Version, andere Addons/Plugins) sollten in die package.yml eingetragen werden.
// Sie brauchen hier dann nicht mehr überprüft werden!

// Hier können zum Beispiel Konfigurationswerte in der rex_config initialisiert werden.
// Das if-Statement ist notwendig, um bei einem reinstall die Konfiguration nicht zu überschreiben.
if (!$this->hasConfig()) {
    $this->setConfig('tags', 'Wichtig, Extra, Raum');
    $this->setConfig('preset_minute_intervall', '15');
}

// Mit einer rex_functional_exception kann die Installation mit einer Fehlermeldung abgebrochen werden.
$somethingIsWrong = false;
if ($somethingIsWrong) {
    throw new rex_functional_exception('Something is wrong');
}

// Alternativ kann ähnlich wie in R4 mit den Properties "install" und "installmsg" die Installation als nicht erfolgreich markiert werden.
// Im Gegensatz zu R4 muss für eine erfolgreiche Installation keine Property mehr gesetzt werden.
if ($somethingIsWrong) {
    $this->setProperty('installmsg', 'Something is wrong');
    $this->setProperty('install', false);
}

$rdxa_event_cal_table = '
CREATE TABLE '.rex::getTable("event_cal_events").' (
  `id` int(11) unsigned NOT NULL auto_increment,
  `title` varchar(512) NOT NULL default \'\',
  `eventjson` text NOT NULL,
  `time_begin` datetime NOT NULL default \'1000-01-01 00:00:00.000000\',
  `time_end` datetime NOT NULL default \'1000-01-01 00:00:00.000000\',
  `tags` text NOT NULL default \'\',
  `eventpreset` text NOT NULL default \'\',
  `section` text NOT NULL default \'\',  
  `update` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`),
  KEY `Datum` (`time_begin`)
)

';

$rdxa_sql = rex_sql::factory();
$rdxa_sql->setQuery($rdxa_event_cal_table);
