<?php

class event_cal_view_config {

  public $errors = '';
  public $html = array();
  public $config = array();

  /**
  * Gibt einen erzeugten HTML Block (meist die HTML Seite) aus
  */
  function html_show() {
    
    echo $this->html_header();
    echo implode(" ", $this->html);
    echo $this->html_footer();
    
  }
  
  function html_header() {
    
    $html = '';
      
    $html .= '
      <form action="'.rex_url::currentBackendPage().'" method="post">
    ';
    
    return $html;
    
  }
  
  function html_footer() {
    
    $html = '';
      
    $html .= '
      </form>
    ';
    
    return $html;
    
  }
  
  function html_add($html) {
    
    $this->html[] .= $html;
    return count($this->html)-1;
    
  }
  
  function html_config_panel() {
    
    $html = '';
    
    $html .= '
      <div class="panel panel-edit">
        <header class="panel-heading"><div class="panel-title">'.rex_i18n::msg('event_cal_page_config_title').'</div></header>
            <div class="panel-body">
            
              <div class="row form-group">
                <div class="col-xs-12 col-sm-4"><label for="rdx_event_cal_tags">'.rex_i18n::msg('event_cal_config_tags').'</label></div>
                <div class="col-xs-12 col-sm-8"><input type="text" name="config[tags]" value="'.rex_config::get('event_cal', 'tags').'" id="rdx_event_cal_tags" name="rdxa_event_cal_title" style="width:100%"></div>
              </div>
              
              <div class="row form-group">
                <div class="col-xs-12 col-sm-4"><label for="rdx_event_cal_minute_intervall">'.rex_i18n::msg('event_cal_config_preset_time_intervall').'</label></div>
                <div class="col-xs-12 col-sm-8"><input type="text" name="config[minute_intervall]" value="'.rex_config::get('event_cal', 'preset_minute_intervall').'" id="rdx_event_cal_minute_intervall" style="width:100%"></div>
              </div>
              
              <div class="row">
                  <div class="col-xs-12">
                  <input type="submit" name="btn_save_config" class="btn btn-default" value="'.rex_i18n::msg('event_cal_save').'" title="'.rex_i18n::msg('event_cal_save').'" />
                  </div>
              </div>
              
            </div>
      </div>    
    ';
    
    return $html;
    
  }
  
}

class event_cal_control_config {
  
  function user_action() {
    
    if ( rex_request('btn_save_config') ) {
      
      $config = rex_request::request('config', 'array');
      
      if ( is_numeric($config['minute_intervall']) and $config['minute_intervall'] > 1 and $config['minute_intervall'] < 59 ) {
          rex_config::set('event_cal', 'preset_minute_intervall', $config['minute_intervall'] );
      } else {
          rex_config::set('event_cal', 'preset_minute_intervall', 15 );      
      }
      rex_config::set('event_cal', 'tags', $config['tags'] );
            
      $rdx_page = new event_cal_view_config();
      $rdx_page->html_add( $rdx_page->html_config_panel() ); 
      $rdx_page->html_show();
      unset($rdx_page);
      
    } else {
      
      $rdx_page = new event_cal_view_config();
      $rdx_page->html_add( $rdx_page->html_config_panel() ); 
      $rdx_page->html_show();
      unset($rdx_page);
  
    }
        
  }
  
}

$main = new event_cal_control_config();
$main->user_action();
