<?php

/**
* html_xxx -> HTML und Layout Elemente
* get_xxx -> Holt irgendwelche Daten
* set_xxx -> Schreibt irgendwelche Daten (meist in DB)
* ui_xxx -> Programmlogik/Bedienung
* sanitize_xxx -> Überprüft Eingabe-Werte 
*/

class event_cal_view_main {
  
  public $errors = '';
  public $html = array();
  public $config = array();
  
  
  function __construct() {
  
    $this->config = array(
      'select_year' => date("Y"), 
      'select_month' => date("m")
    );
    
  }
  
  /**
  * Gibt einen erzeugten HTML Block (meist die HTML Seite) aus
  */
  function html_show() {
    
    echo $this->html_header();
    echo implode(" ", $this->html);
    echo $this->html_footer();
    
  }
  
  function html_header() {
    
    $html = '';
      
    $html .= '
      <form action="'.rex_url::currentBackendPage().'" method="post">
    ';
    
    return $html;
    
  }
  
  function html_footer() {
    
    $html = '';
      
    $html .= '
      </form>
    ';
    
    return $html;
    
  }
  
  function html_add($html) {
    
    $this->html[] .= $html;
    return count($this->html)-1;
    
  }
  
  /**
  * Gibt alle Events eines Zeitintervalls (Monats) aus
  */
  function html_events_view($datalist, $last_id=0) {
    
    $html = '
    <div class="panel panel-info">
    <header class="panel-heading"><div class="panel-title">'.rex_i18n::msg("event_cal_event_view").' - '.rex_i18n::msg("event_cal_month".$this->config['select_month']).' '.$this->config['select_year'].'</div></header>
    <div class="panel-body">
    ';
    
    // Neuer Eintrag
    $html .= '        
        <div class="row" style="border-bottom:1px dotted silver;">
          <div class="col-xs-2 col-sm-2"></br>&nbsp;</br></div>
          <div class="col-xs-10 col-sm-3">&nbsp;</div>
          <div class="col-xs-12 col-sm-4">&nbsp;</div>
          <div class="col-xs-12 col-sm-3 text-right">
            <a href="'.rex_url::currentBackendPage().'&new=-1"><i class="rex-icon rex-icon-edit"></i> '.rex_i18n::msg("event_cal_ui_new").'</a>
          </div>
        </div>
    ';
    
    if ( $datalist->firstId() != 0 ) {
      $datalist->get($datalist->firstId()); 
    }
    for ($i = 1; $i <= date("t", strtotime($this->config['select_year'].'-'.$this->config['select_month'].'-01') ); $i++ ) {
    
      $date = date("Y-m-d", strtotime($this->config['select_year'].'-'.$this->config['select_month'].'-'.$i) );
      $day = date("d", strtotime($this->config['select_year'].'-'.$this->config['select_month'].'-'.$i) );
      $marker_class = '';
      
      if ( date("Y-m-d", strtotime($datalist->getTimeStart())) == $date ) {
        
        if ( $last_id == $datalist->getId() ) {
          $marker_class = ' alert-success';
        }
        
        $html .= '
          <div class="row'.$marker_class.'" style="border-bottom:1px dotted silver;">
            <div class="col-xs-12 col-sm-1 btn-info">'.$day.' '.$this->html_weekday($date).'</div>
            <div class="col-xs-12 col-sm-5">'.$datalist->getTitle().'</br>'.$this->html_tags($datalist->getTagsStatus()).'</div>
            <div class="col-xs-8 col-sm-3">'.$datalist->getTimeStart().'</br>'.$datalist->getTimeEnd().'</div>
            <div class="col-xs-4 col-sm-3 text-right">
              <a href="'.rex_url::currentBackendPage().'&edit='.$datalist->getId().'"><i class="rex-icon rex-icon-edit"></i> '.rex_i18n::msg("event_cal_ui_edit").'</a>
            </div>
          </div>                  
        ';
        
        $datalist->get( $datalist->nextId() );
        
      } else {
        
        $html .= '
          <div class="row'.$marker_class.'" style="border-bottom:1px dotted silver;">
            <div class="col-xs-12 col-sm-1">'.$day.' '.$this->html_weekday($date).'</div>
            <div class="col-xs-12 col-sm-5"></div>
            <div class="col-xs-8 col-sm-3"></br></div>
            <div class="col-xs-4 col-sm-3 text-right">
              
            </div>
          </div>        
        ';
        
      }
      
      while ( date("Y-m-d", strtotime($datalist->getTimeStart())) == $date ) {

        $marker_class = '';
        if ( $last_id == $datalist->getId() ) {
          $marker_class = ' alert-success';
        }
      
        $html .= '
          <div class="row'.$marker_class.'" style="border-bottom:1px dotted silver;">
            <div class="hidden-xs-down col-sm-1"></div>
            <div class="col-xs-12 col-sm-5">'.$datalist->getTitle().'</br>'.$this->html_tags($datalist->getTagsStatus()).'</div>
            <div class="col-xs-8 col-sm-3">'.$datalist->getTimeStart().'</br>'.$datalist->getTimeEnd().'</div>
            <div class="col-xs-4 col-sm-3 text-right">
              <a href="'.rex_url::currentBackendPage().'&edit='.$datalist->getId().'"><i class="rex-icon rex-icon-edit"></i> '.rex_i18n::msg("event_cal_ui_edit").'</a>
            </div>
          </div>        
        ';
        
        $datalist->get( $datalist->nextId() );
        
      }
            
      /**
      foreach ($datalist->id_list as $k => $id) {
        
      
        $marker_class = '';
        if ( $last_id == $id ) {
          $marker_class = ' alert-success';
        }

        $html .= '        
            <div class="row'.$marker_class.'" style="border-bottom:1px dotted silver;">
              <div class="col-xs-2 col-sm-2">'.$this->html_weekday($datalist->getTimeStart()).'</div>
              <div class="col-xs-10 col-sm-3">'.$datalist->getTimeStart().'</br>'.$datalist->getTimeEnd().'</div>
              <div class="col-xs-12 col-sm-4">'.$datalist->getTitle().'</div>
              <div class="col-xs-12 col-sm-3 text-right">
                <a href="'.rex_url::currentBackendPage().'&edit='.$datalist->getId().'"><i class="rex-icon rex-icon-edit"></i> '.rex_i18n::msg("event_cal_ui_edit").'</a>
              </div>
            </div>
        ';
        
      }
      */
    
    }
    return $html;
    
  }
  
  /** 
  * Erzeugt ein Formular zur Auswahl eines Zeitabschnittes
  */
  function html_select_time_intervall () {
        
    $select_month = new rex_select;
    $select_month->setName("event_cal_view_month");
    for ($i=1;$i<=12;$i++) {
      $select_month->addOption(rex_i18n::msg('event_cal_month'.date("m", mktime(0,0,0,$i,7,2000))), date("m", mktime(0,0,0,$i,7,2000)));	
    }
    $select_month->setSelected( $this->config['select_month'] );
    $select_month->setSize("1");
    
    $select_year = new rex_select;
    $select_year->setName("event_cal_view_year");
    for ($i=date("Y")-1; $i<=date("Y") + 1; $i++) {
      $select_year->addOption($i, $i);
    }
    $select_year->setSelected( $this->config['select_year'] );
    $select_year->setSize("1");
    
    $html = '
      <div class="panel panel-edit">
        <header class="panel-heading"><div class="panel-title">'.rex_i18n::msg('event_cal_select_title').'</div></header>
        
        <div class="panel-body">
        
          <div class="row form-group">
            <div class="col-xs-12">
            '.$select_month->get().' '.$select_year->get().' 
            </div>
          </div>
        
          <div class="row">
            <div class="col-xs-12">
              <input type="submit" name="btn_select_intervall" class="btn btn-default" value="'.rex_i18n::msg('event_cal_select').'"  title="'.rex_i18n::msg('event_cal_select').'" />             
            </div>
          </div>
          
        </div>
      </div>
    ';
    
    return $html;
    
  }
  
  /**
  * Gibt ein Formular zur Bearbeitung/Neueinfügung der Events aus
  */
  function html_edit_panel ($data) {
    
    $id = $data->getId();
    
    $html = '    
      <div class="panel panel-edit">
        <header class="panel-heading"><div class="panel-title">'.rex_i18n::msg('event_cal_panel_title').'</div></header>
            <div class="panel-body">
            
              <div class="row form-group">
                <div class="col-xs-12 col-sm-4"><label for="rdxa_event_cal_title">'.rex_i18n::msg('event_cal_eventtitle').'</label></div>
                <div class="col-xs-12 col-sm-8"><input type="text" name="in['.$id.'][title]" value="'.$data->getTitle().'" id="rdxa_event_cal_title" name="rdxa_event_cal_title" style="width:100%"></div>
              </div>

              <div class="row form-group">
                <div class="col-xs-12 col-sm-4"><label for="rdxa_event_cal_start">'.rex_i18n::msg('event_cal_datetime').'</label></div>
                <div class="col-xs-6 col-sm-4"><input type="text" name="in['.$id.'][start]" value="'.$data->getTimeStart().'" id="rdxa_event_cal_start" name="event_cal_time_start" style="width:100%"></div>
                <div class="col-xs-6 col-sm-4"><input type="text" name="in['.$id.'][end]" value="'.$data->getTimeEnd().'" id="rdxa_event_cal_end" style="width:100%"></div>
              </div>
              
              <div class="row form-group">
                <div class="col-xs-12 col-sm-4"><label for="rdxa_event_cal_desc">'.rex_i18n::msg('event_cal_description').'</label></div>
                <div class="col-xs-12 col-sm-8"><textarea name="in['.$id.'][desc]" id="rdxa_event_cal_desc" rows="3" style="width:100%">'.$data->getDescription().'</textarea></div>
              </div>
              
              <div class="row form-group">
                <div class="col-xs-12 col-sm-4"><label>'.rex_i18n::msg('event_cal_tags').'</label></div>
                <div class="col-xs-12 col-sm-8">
                  '.$this->html_tags_panel ($data->getTagsStatus(), $id).'
                </div>
              </div>      
              
              <div class="row">
                  <div class="col-xs-6">
                  <input type="submit" name="btn_save" class="btn btn-default" value="'.rex_i18n::msg('event_cal_save').'" title="'.rex_i18n::msg('event_cal_save').'" />
                  </div>
                  <div class="col-xs-6 text-right">
                  <input type="submit" name="btn_delete" class="btn btn-warning" value="'.rex_i18n::msg("event_cal_ui_delete").'" title="'.rex_i18n::msg("event_cal_ui_delete").'" />
                  </div>
              </div>
              
            </div>
      </div>
      
      <script type="text/javascript">
        $(function() {
          $( "#rdxa_event_cal_start" ).datetimepicker({
            timeInput: true, // Zeit kann auch manuell eingetippt werden
          	timeFormat: "HH:mm",
            dateFormat: "yy-mm-dd",
            stepHour: 1,
            stepMinute: '.rex_config::get('event_cal', 'preset_minute_intervall').',
            controlType: "select", // Zeit wid als Select-Feld statt als Slider ausgeben (Slider bei Touch mit weiterem JS möglich)
          });
          $( "#rdxa_event_cal_end" ).datetimepicker({
            timeInput: true, // Zeit kann auch manuell eingetippt werden
          	timeFormat: "HH:mm",
            dateFormat: "yy-mm-dd",
            stepHour: 1,
            stepMinute: '.rex_config::get('event_cal', 'preset_minute_intervall').',
            controlType: "select", // Zeit wid als Select-Feld statt als Slider ausgeben (Slider bei Touch mit weiterem JS möglich)
          });
        });
      </script>
    ';
    
    return $html;
    
  }
  
  function html_tags_panel ($tags, $id) {
    
    $html = '';
    
    foreach ($tags as $k => $v) {
      $html .= ''.$v["name"].' <input type="checkbox" name="in['.$id.'][tags][]" value="'.$v['name'].'" '.$v["checked"].'> '; 
    }
    
    return $html;
    
  }
  
  function html_tags ($tags) {
    
    $html = '<i class="rex-icon rex-icon-package-addon" style="font-size:9px;"></i> <span style="font-size:9px;">';
    
    foreach ($tags as $k => $v) {
      if ( $v["checked"] == "checked" ) {
        $html .= '['.$v["name"].'] ';
      }
    }
    
    return $html.'</span>';
    
  }
  
  function html_confirm_delete_panel ($id) {
    
    $html = '';
    
    $html .= '
      <div class="alert alert-danger">
        '.rex_i18n::msg('event_cal_confirm_delete_dialog').' &nbsp; 
        <input type="submit" class="btn btn-default" name="btn_del_confirm_no['.$id.']" value="'.rex_i18n::msg('event_cal_ui_btn_confirm_no').'" title="'.rex_i18n::msg('event_cal_ui_btn_confirm_no').'" /> 
        <input type="submit" class="btn btn-warning" name="btn_del_confirm_yes['.$id.']" value="'.rex_i18n::msg('event_cal_ui_btn_confirm_yes').'" title="'.rex_i18n::msg('event_cal_ui_btn_confirm_yes').'" /> 
      </div>
    ';
    
    return $html;
    
  }

  /**
  * Gibt den übersetzten Wochentag (2 BS) zurück
  */
  function html_weekday ($date) {
    
    $weekday = rex_i18n::msg('event_cal_day'.date("N", strtotime($date)).'sh');
    
    return $weekday;
    
  }
  
}

class event_cal_control_main {
  
  public $errors = '';
  
  function user_action () {
      
    if ( rex_request('new', 'int') and rex_request('new', 'int') == -1 ) {
      $this->ui_btn_new_clicked();
    } 
    elseif ( rex_request('edit', 'int') ) {
      $this->ui_btn_edit_clicked();
    }    
    elseif ( rex_request('del', 'int') ) {
      $this->ui_btn_delete_clicked();
    }    
    elseif ( rex_request('btn_save') ) {
      $this->ui_btn_saveevent_clicked();
    }    
    elseif ( rex_request('btn_delete') ) {
      $this->ui_btn_delete_clicked();
    }    
    elseif ( rex_request('btn_del_confirm_yes', 'array') and is_int( key( rex_request('btn_del_confirm_yes', 'array') ) ) )  {
      $this->ui_btn_confirm_delete_yes();      
    }
    elseif ( rex_request('btn_del_confirm_no', 'array') and is_int( key( rex_request('btn_del_confirm_no', 'array') ) ) ) {
      $this->ui_btn_confirm_delete_no();  
    }    
    elseif ( rex_request('btn_select_intervall') ) {
      $this->ui_btn_select_intervall();
    } 
    else {
      $this->ui_start();
    }
      
  }
  
  function ui_start() {
    
    $rdx_data = new event_cal_data();
    $rdx_data->get_intervall_list( date("Y"), date("m") );
    
    $rdx_page = new event_cal_view_main();
    $rdx_page->html_add( $rdx_page->html_select_time_intervall() );    
    $rdx_page->html_add( $rdx_page->html_events_view($rdx_data) );
    $rdx_page->html_show();
    
    unset($rdx_page);
    
  }
  
  function ui_btn_new_clicked () {

    $rdx_data = new event_cal_data();
    $rdx_data->get(-1);
  
    $rdx_page = new event_cal_view_main();
    $rdx_page->html_add( $rdx_page->html_edit_panel( $rdx_data ) );
    $rdx_page->html_show();
    
    unset($rdx_page);
      
  }
  
  function ui_btn_edit_clicked () {
    
    $rdx_data = new event_cal_data();
    $rdx_data->get( rex_request('edit', 'int') ); 
    
    $rdx_page = new event_cal_view_main();    
    $rdx_page->html_add( $rdx_page->html_edit_panel($rdx_data) );
    $rdx_page->html_show();
    
    unset($rdx_page);
        
  }
  
  function ui_btn_delete_clicked () {
    
    $data = rex_request('in', 'array');
    $id = key($data);
    
    $rdx_data = new event_cal_data();
    $rdx_data->get($id); 
    
    $rdx_page = new event_cal_view_main();
    $rdx_page->html_add( $rdx_page->html_confirm_delete_panel( $id ) );
    $rdx_page->html_add( $rdx_page->html_edit_panel($rdx_data) );
    $rdx_page->html_show();
    
    unset($rdx_page);
        
  }
  
  function ui_btn_confirm_delete_yes() {
    
    $id = key( rex_request('btn_del_confirm_yes', 'array') );
    $rdx_data = new event_cal_data();
    $rdx_data->del_event($id);
    
    $year = date("Y", strtotime($rdx_data->getTimeStart()));
    $month = date("m", strtotime($rdx_data->getTimeStart()));
    $id = $rdx_data->getId();
    unset($rdx_data);    
    
    $rdx_data = new event_cal_data();
    $rdx_data->get_intervall_list( $year, $month );
    
    $rdx_page = new event_cal_view_main();
    $rdx_page->config['select_year'] = $year;
    $rdx_page->config['select_month'] = $month;    
    $rdx_page->html_add( $rdx_page->html_select_time_intervall() );
    $rdx_page->html_add( $rdx_page->html_events_view($rdx_data) );
    $rdx_page->html_show();  
    
    unset($rdx_page);
        
  }
  
  function ui_btn_confirm_delete_no() {
    
    $id = key( rex_request('btn_del_confirm_no', 'array') );
    $rdx_data = new event_cal_data();
    $rdx_data->get($id);
    $year = date("Y", strtotime($rdx_data->getTimeStart()));
    $month = date("m", strtotime($rdx_data->getTimeStart()));
    $id = $rdx_data->getId();
    unset($rdx_data);    
    
    $rdx_data = new event_cal_data();
    $rdx_data->get_intervall_list( $year, $month );
    
    $rdx_page = new event_cal_view_main();
    $rdx_page->config['select_year'] = $year;
    $rdx_page->config['select_month'] = $month;    
    $rdx_page->html_add( $rdx_page->html_select_time_intervall() );
    $rdx_page->html_add( $rdx_page->html_events_view($rdx_data) );
    $rdx_page->html_show();
    
    unset($rdx_page);
  
  }
  
  function ui_btn_saveevent_clicked() {
    
    $data = rex_request('in', 'array');
    $rdx_data = new event_cal_data();
    $rdx_data->set_event($data);
    
    $year = date("Y", strtotime($rdx_data->getTimeStart()));
    $month = date("m", strtotime($rdx_data->getTimeStart()));
    $id = $rdx_data->getId();
    unset($rdx_data);
    
    $rdx_data = new event_cal_data();
    $rdx_data->get_intervall_list( $year, $month );
    
    $rdx_page = new event_cal_view_main();
    $rdx_page->config['select_year'] = $year;
    $rdx_page->config['select_month'] = $month;
    $rdx_page->html_add( $rdx_page->html_select_time_intervall() );
    $rdx_page->html_add( $rdx_page->html_events_view($rdx_data, $id) );
    $rdx_page->html_show();
    
    unset($rdx_page);
    
  }
  
  function ui_btn_select_intervall() {
        
    $year = event_cal_sanitize::sanitizeEventTime(rex_request('event_cal_view_year').'-01-01', "Y");
    $month = event_cal_sanitize::sanitizeEventTime('2016-'.rex_request('event_cal_view_month').'-01', "m");
  
    $rdx_data = new event_cal_data();
    $rdx_data->get_intervall_list( $year, $month );
    
    $rdx_page = new event_cal_view_main();
    $rdx_page->config['select_year'] = $year;
    $rdx_page->config['select_month'] = $month;    
    $rdx_page->html_add( $rdx_page->html_select_time_intervall() );    
    $rdx_page->html_add( $rdx_page->html_events_view($rdx_data) );
    $rdx_page->html_show();
    
    unset($rdx_page);
    unset($rdx_data);
        
  }
  
}


$rdxa_ui = new event_cal_control_main();
$rdxa_ui->user_action();



