<?php
/**
 * @Autor: redaxoist (rdx)
 * @Typ:   modul-output
 * @Date:  2016-04-02
 */

// Klasse für das Datenmodell
if ( !class_exists('event_cal_data') ) {
    // Bindet die Klasse für das Datenmodell ein
    require_once( rex_path::addon('event_cal', 'lib/class.event_cal_data.php') ); 
} 

// Klasse für das Controlling
if ( !class_exists('rdx_event_cal_mcontrol') ) {
class rdx_event_cal_mcontrol {
    
    public $params = array();
    
    function __construct () {
        
        $this->params['year'] = date("Y");
        $this->params['month'] = date("n");
        
        $this->main();

    }
    
    function main () {
    
        if ( rex_request('btn_select') ) {
            
            $year = rex_request('event_cal_view_year', 'int');
            $month = rex_request('event_cal_view_month', 'int');
                        
            $rdx_data = new event_cal_data;
            $rdx_data->get_intervall_list( $year, $month );
            
            $rdx_page = new rdx_event_cal_mview;
            $rdx_page->params['select_year'] = $year;
            $rdx_page->params['select_month'] = $month;
            echo $rdx_page->html_select_form();
            echo $rdx_page->html_list($rdx_data);
            
        } else {
            
            $rdx_page = new rdx_event_cal_mview;
            echo $rdx_page->html_select_form();

            echo "Es wurde kein Zeitraum ausgewählt";
       
        }
    
    }
    
}
}

// Klasse für View / HTML Output
if ( !class_exists('rdx_event_cal_mview') ) {
class rdx_event_cal_mview {
    
    public $params = array();
    
    function __construct() {
        
        $this->params['select_year'] = date("Y");
        $this->params['select_month'] = date("n");
        
    }

    function monthToDe($monthNbr) {
        
        $monthsDe = array(
            1 => "Januar", 
            2 => "Februar", 
            3 => "März", 
            4 => "April", 
            5 => "Mai", 
            6 => "Juni", 
            7 => "Juli", 
            8 => "August", 
            9 => "September", 
            10 => "Oktober", 
            11 => "November", 
            12 => "Dezember" 
        );
        
        return $monthsDe[$monthNbr];
        
    }
    
    function html_select_form() {
    
        $html = '';
        
        $select_month = new rex_select;
        $select_month->setName("event_cal_view_month");
        for ($i=1;$i<=12;$i++) {
          $select_month->addOption($this->monthToDe($i), $i);
        }
        $select_month->setSelected( $this->params['select_month'] );
        $select_month->setSize("1");
    
        $select_year = new rex_select;
        $select_year->setName("event_cal_view_year");
        for ($i=date("Y")-1; $i<=date("Y") + 1; $i++) {
          $select_year->addOption($i, $i);
        }
        $select_year->setSelected( $this->params['select_year'] );
        $select_year->setSize("1");        
        
        
        $html .= '
            <form action="'.rex_getUrl().'" method="post">
            '.$select_month->get().' '.$select_year->get().' <input type="submit" value="Auswählen" name="btn_select">
            </form>
        ';
        
        return $html;
        
    }
    
    /**
    * Listet die Ereignisse auf
    */
    function html_list ($datalist) {
        
        $html = '';
        
        foreach ($datalist->id_list as $pos => $event_id) {
            
            $datalist->get($event_id);
                
            $html .= '
                <div style="width:100%;margin-bottom:10px;border-bottom:1px dotted silver;">
                    <div>
                        <b>Titel: </b>'.$datalist->getTitle().'
                        </br><b>Beginn: </b>'.$datalist->getTimeStart().'
                        </br><b>Ende: </b>'.$datalist->getTimeEnd().'
                        </br><b>Beschreibung: </b>'.$datalist->getDescription().'
                        </br><b>Tags: </b>'.$datalist->getTags().'
                    </div>                    
                </div>
            ';
            
        }
        
        echo $html;
    
    }

}
}

$rdx_control = new rdx_event_cal_mcontrol;

?>